// CTestInterface.cpp : implementation file
// Written by Francesco Germinara  2001-2002
// Last Update: 10-08-2001
// Please for any suggestions or comments, contact me 
// at E-Mail: franco@germinara.it or visit
// Web: http://www.germinara.it
/////////////////////////////////////////////////////
// NOTE: To access direct hardware port in NT or 2000 
//       system, please download and buy the NTPORT
//       driver.
//       NTPort Library
//       Copyright  1997-2001 Hai Li, Zeal SoftStudio.
//       E-Mail: support@zealsoftstudio.com
//       Web: http://www.zealsoftstudio.com
//
//       For 95/98 system, no drivers is necessary.
//       Enjoy yourself.
/////////////////////////////////////////////////////

#include "stdafx.h"
#include "PortTest.h"
#include "CTestInterface.h"
#include "conio.h"
#include "NTPORT.h"

#define DIRECTACCESS 2
#define DRIVERACCESS 1

#define WNT  1 //no hardware direct access  Nt Family
#define W2K  1 //no hardware direct access  2000 Family
#define WXP  1 //no hardware direct access  XP Family

#define W95  2 //hardware direct access allowed Windows 95 Family
#define W98  2 //hardware direct access allowed Windows 98 Family
#define WME  2 //hardware direct access allowed Windows Millenium Editions Family
#define W32S 2 //hardware direct access allowed Windows 3.11 Family


//Conversione BYTE-BIT'S
union{
 struct{
  unsigned char low:4;
  unsigned char high:4;
 }nibble;
 struct{
  unsigned char b0:1;
  unsigned char b1:1;
  unsigned char b2:1;
  unsigned char b3:1;
  unsigned char b4:1;
  unsigned char b5:1;
  unsigned char b6:1;
  unsigned char b7:1;
 }bit;
 BYTE byte;
}dato;

//Conversione da WORD a BYTE'S
union{
 struct dataword{
  unsigned char msb;
  unsigned char lsb;
 }byte;
 WORD dw;
}word;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestInterface dialog


CTestInterface::CTestInterface(CWnd* pParent /*=NULL*/)
	: CDialog(CTestInterface::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestInterface)
	m_bChk1_0 = FALSE;
	m_bChk1_1 = FALSE;
	m_bChk1_2 = FALSE;
	m_bChk1_3 = FALSE;
	m_bChk1_4 = FALSE;
	m_bChk1_5 = FALSE;
	m_bChk1_6 = FALSE;
	m_bChk1_7 = FALSE;
	m_bChk2_0 = FALSE;
	m_bChk2_1 = FALSE;
	m_bChk2_2 = FALSE;
	m_bChk2_3 = FALSE;
	m_bChk2_4 = FALSE;
	m_bChk2_5 = FALSE;
	m_bChk2_6 = FALSE;
	m_bChk2_7 = FALSE;
	m_bChk3_0 = FALSE;
	m_bChk3_1 = FALSE;
	m_bChk3_2 = FALSE;
	m_bChk3_3 = FALSE;
	m_bChk3_4 = FALSE;
	m_bChk3_5 = FALSE;
	m_bChk3_6 = FALSE;
	m_bChk3_7 = FALSE;
	m_bChk4_0 = FALSE;
	m_bChk4_1 = FALSE;
	m_bChk4_2 = FALSE;
	m_bChk4_3 = FALSE;
	m_bChk4_4 = FALSE;
	m_bChk4_5 = FALSE;
	m_bChk4_6 = FALSE;
	m_bChk4_7 = FALSE;
	m_bChk5_0 = FALSE;
	m_bChk5_1 = FALSE;
	m_bChk5_2 = FALSE;
	m_bChk5_3 = FALSE;
	m_bChk5_4 = FALSE;
	m_bChk5_5 = FALSE;
	m_bChk5_6 = FALSE;
	m_bChk5_7 = FALSE;
	m_bChk6_0 = FALSE;
	m_bChk6_1 = FALSE;
	m_bChk6_2 = FALSE;
	m_bChk6_3 = FALSE;
	m_bChk6_4 = FALSE;
	m_bChk6_5 = FALSE;
	m_bChk6_6 = FALSE;
	m_bChk6_7 = FALSE;
	m_bChk7_0 = FALSE;
	m_bChk7_1 = FALSE;
	m_bChk7_2 = FALSE;
	m_bChk7_3 = FALSE;
	m_bChk7_4 = FALSE;
	m_bChk7_5 = FALSE;
	m_bChk7_6 = FALSE;
	m_bChk7_7 = FALSE;
	m_bChk8_0 = FALSE;
	m_bChk8_1 = FALSE;
	m_bChk8_2 = FALSE;
	m_bChk8_3 = FALSE;
	m_bChk8_4 = FALSE;
	m_bChk8_5 = FALSE;
	m_bChk8_6 = FALSE;
	m_bChk8_7 = FALSE;
	m_strBse0 = _T("378");
	m_strVal0 = _T("0");
	m_strVal1 = _T("0");
	m_strVal2 = _T("0");
	m_strVal3 = _T("0");
	m_strVal4 = _T("0");
	m_strVal5 = _T("0");
	m_strVal6 = _T("0");
	m_strVal7 = _T("0");
	m_strVersioneOS = _T("");
	m_bAutoRefresh = FALSE;
	m_strTmTimer = _T("500");
	m_bTestMode = FALSE;
	//}}AFX_DATA_INIT

	sscanf(m_strBse0, "%x", &m_nPortBse);
    m_strBse1.Format("%x",m_nPortBse+1);
	m_strBse2.Format("%x",m_nPortBse+2);
    m_strBse3.Format("%x",m_nPortBse+0x400);
	m_strBse4.Format("%x",m_nPortBse+0x401);
    m_strBse5.Format("%x",m_nPortBse+0x402);
	m_strBse6.Format("%x",m_nPortBse+3);
    m_strBse7.Format("%x",m_nPortBse+4);
	m_nWrtBit=0;

	tmSleep=atoi(m_strTmTimer);
}


void CTestInterface::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestInterface)
	DDX_Check(pDX, IDC_CHECK1_0, m_bChk1_0);
	DDX_Check(pDX, IDC_CHECK1_1, m_bChk1_1);
	DDX_Check(pDX, IDC_CHECK1_2, m_bChk1_2);
	DDX_Check(pDX, IDC_CHECK1_3, m_bChk1_3);
	DDX_Check(pDX, IDC_CHECK1_4, m_bChk1_4);
	DDX_Check(pDX, IDC_CHECK1_5, m_bChk1_5);
	DDX_Check(pDX, IDC_CHECK1_6, m_bChk1_6);
	DDX_Check(pDX, IDC_CHECK1_7, m_bChk1_7);
	DDX_Check(pDX, IDC_CHECK2_0, m_bChk2_0);
	DDX_Check(pDX, IDC_CHECK2_1, m_bChk2_1);
	DDX_Check(pDX, IDC_CHECK2_2, m_bChk2_2);
	DDX_Check(pDX, IDC_CHECK2_3, m_bChk2_3);
	DDX_Check(pDX, IDC_CHECK2_4, m_bChk2_4);
	DDX_Check(pDX, IDC_CHECK2_5, m_bChk2_5);
	DDX_Check(pDX, IDC_CHECK2_6, m_bChk2_6);
	DDX_Check(pDX, IDC_CHECK2_7, m_bChk2_7);
	DDX_Check(pDX, IDC_CHECK3_0, m_bChk3_0);
	DDX_Check(pDX, IDC_CHECK3_1, m_bChk3_1);
	DDX_Check(pDX, IDC_CHECK3_2, m_bChk3_2);
	DDX_Check(pDX, IDC_CHECK3_3, m_bChk3_3);
	DDX_Check(pDX, IDC_CHECK3_4, m_bChk3_4);
	DDX_Check(pDX, IDC_CHECK3_5, m_bChk3_5);
	DDX_Check(pDX, IDC_CHECK3_6, m_bChk3_6);
	DDX_Check(pDX, IDC_CHECK3_7, m_bChk3_7);
	DDX_Check(pDX, IDC_CHECK4_0, m_bChk4_0);
	DDX_Check(pDX, IDC_CHECK4_1, m_bChk4_1);
	DDX_Check(pDX, IDC_CHECK4_2, m_bChk4_2);
	DDX_Check(pDX, IDC_CHECK4_3, m_bChk4_3);
	DDX_Check(pDX, IDC_CHECK4_4, m_bChk4_4);
	DDX_Check(pDX, IDC_CHECK4_5, m_bChk4_5);
	DDX_Check(pDX, IDC_CHECK4_6, m_bChk4_6);
	DDX_Check(pDX, IDC_CHECK4_7, m_bChk4_7);
	DDX_Check(pDX, IDC_CHECK5_0, m_bChk5_0);
	DDX_Check(pDX, IDC_CHECK5_1, m_bChk5_1);
	DDX_Check(pDX, IDC_CHECK5_2, m_bChk5_2);
	DDX_Check(pDX, IDC_CHECK5_3, m_bChk5_3);
	DDX_Check(pDX, IDC_CHECK5_4, m_bChk5_4);
	DDX_Check(pDX, IDC_CHECK5_5, m_bChk5_5);
	DDX_Check(pDX, IDC_CHECK5_6, m_bChk5_6);
	DDX_Check(pDX, IDC_CHECK5_7, m_bChk5_7);
	DDX_Check(pDX, IDC_CHECK6_0, m_bChk6_0);
	DDX_Check(pDX, IDC_CHECK6_1, m_bChk6_1);
	DDX_Check(pDX, IDC_CHECK6_2, m_bChk6_2);
	DDX_Check(pDX, IDC_CHECK6_3, m_bChk6_3);
	DDX_Check(pDX, IDC_CHECK6_4, m_bChk6_4);
	DDX_Check(pDX, IDC_CHECK6_5, m_bChk6_5);
	DDX_Check(pDX, IDC_CHECK6_6, m_bChk6_6);
	DDX_Check(pDX, IDC_CHECK6_7, m_bChk6_7);
	DDX_Check(pDX, IDC_CHECK7_0, m_bChk7_0);
	DDX_Check(pDX, IDC_CHECK7_1, m_bChk7_1);
	DDX_Check(pDX, IDC_CHECK7_2, m_bChk7_2);
	DDX_Check(pDX, IDC_CHECK7_3, m_bChk7_3);
	DDX_Check(pDX, IDC_CHECK7_4, m_bChk7_4);
	DDX_Check(pDX, IDC_CHECK7_5, m_bChk7_5);
	DDX_Check(pDX, IDC_CHECK7_6, m_bChk7_6);
	DDX_Check(pDX, IDC_CHECK7_7, m_bChk7_7);
	DDX_Check(pDX, IDC_CHECK8_0, m_bChk8_0);
	DDX_Check(pDX, IDC_CHECK8_1, m_bChk8_1);
	DDX_Check(pDX, IDC_CHECK8_2, m_bChk8_2);
	DDX_Check(pDX, IDC_CHECK8_3, m_bChk8_3);
	DDX_Check(pDX, IDC_CHECK8_4, m_bChk8_4);
	DDX_Check(pDX, IDC_CHECK8_5, m_bChk8_5);
	DDX_Check(pDX, IDC_CHECK8_6, m_bChk8_6);
	DDX_Check(pDX, IDC_CHECK8_7, m_bChk8_7);
	DDX_Text(pDX, IDC_EDT_BSE0, m_strBse0);
	DDX_Text(pDX, IDC_STR_VAL_0, m_strVal0);
	DDX_Text(pDX, IDC_EDT_BSE1, m_strBse1);
	DDX_Text(pDX, IDC_STR_VAL_1, m_strVal1);
	DDX_Text(pDX, IDC_EDT_BSE2, m_strBse2);
	DDX_Text(pDX, IDC_STR_VAL_2, m_strVal2);
	DDX_Text(pDX, IDC_EDT_BSE3, m_strBse3);
	DDX_Text(pDX, IDC_STR_VAL_3, m_strVal3);
	DDX_Text(pDX, IDC_EDT_BSE4, m_strBse4);
	DDX_Text(pDX, IDC_STR_VAL_4, m_strVal4);
	DDX_Text(pDX, IDC_EDT_BSE5, m_strBse5);
	DDX_Text(pDX, IDC_STR_VAL_5, m_strVal5);
	DDX_Text(pDX, IDC_EDT_BSE6, m_strBse6);
	DDX_Text(pDX, IDC_STR_VAL_6, m_strVal6);
	DDX_Text(pDX, IDC_EDT_BSE7, m_strBse7);
	DDX_Text(pDX, IDC_STR_VAL_7, m_strVal7);
	DDX_Text(pDX, IDC_STS_INFOVER, m_strVersioneOS);
	DDX_Check(pDX, IDC_CHK_TMREAD, m_bAutoRefresh);
	DDX_Text(pDX, IDC_EDT_TM, m_strTmTimer);
	DDX_Check(pDX, IDC_CHK_TEST, m_bTestMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTestInterface, CDialog)
	//{{AFX_MSG_MAP(CTestInterface)
	ON_BN_CLICKED(IDC_BTN_READ0, OnBtnRead0)
	ON_BN_CLICKED(IDC_BTN_WRITE0, OnBtnWrite0)
	ON_BN_CLICKED(IDC_BTN_READ1, OnBtnRead1)
	ON_BN_CLICKED(IDC_BTN_WRITE1, OnBtnWrite1)
	ON_BN_CLICKED(IDC_BTN_READ2, OnBtnRead2)
	ON_BN_CLICKED(IDC_BTN_WRITE2, OnBtnWrite2)
	ON_BN_CLICKED(IDC_BTN_READ3, OnBtnRead3)
	ON_BN_CLICKED(IDC_BTN_WRITE3, OnBtnWrite3)
	ON_BN_CLICKED(IDC_BTN_READ4, OnBtnRead4)
	ON_BN_CLICKED(IDC_BTN_WRITE4, OnBtnWrite4)
	ON_BN_CLICKED(IDC_BTN_READ5, OnBtnRead5)
	ON_BN_CLICKED(IDC_BTN_WRITE5, OnBtnWrite5)
	ON_BN_CLICKED(IDC_BTN_READ6, OnBtnRead6)
	ON_BN_CLICKED(IDC_BTN_WRITE6, OnBtnWrite6)
	ON_BN_CLICKED(IDC_BTN_READ7, OnBtnRead7)
	ON_BN_CLICKED(IDC_BTN_WRITE7, OnBtnWrite7)
	ON_EN_CHANGE(IDC_EDT_BSE0, OnChangeEdtBse0)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHK_TMREAD, OnChkTmread)
	ON_EN_SETFOCUS(IDC_EDT_TM, OnSetfocusEdtTm)
	ON_EN_KILLFOCUS(IDC_EDT_TM, OnKillfocusEdtTm)
	ON_BN_CLICKED(IDC_CHK_TEST, OnChkTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestInterface message handlers
BOOL CTestInterface::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	GetSystemVersion(nVersione,vers,tipo,srvpack);
    m_strVersioneOS=vers+" "+srvpack;
	
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTestInterface::OnBtnRead0() 
{
 int addr=0;
 sscanf(m_strBse0, "%x", &addr);
 OnRead(addr,0);
}
void CTestInterface::OnBtnWrite0() 
{
 int addr=0;
 sscanf(m_strBse0, "%x", &addr);
 OnWrite(addr,0);
}
void CTestInterface::OnBtnRead1() 
{
 int addr=0;
 sscanf(m_strBse1, "%x", &addr);
 OnRead(addr,1);

}
void CTestInterface::OnBtnWrite1() 
{
 int addr=0;
 sscanf(m_strBse1, "%x", &addr);
 OnWrite(addr,1);
}
void CTestInterface::OnBtnRead2() 
{
 int addr=0;
 sscanf(m_strBse2, "%x", &addr);
 OnRead(addr,2);
}
void CTestInterface::OnBtnWrite2() 
{
 int addr=0;
 sscanf(m_strBse2, "%x", &addr);
 OnWrite(addr,2);
}
void CTestInterface::OnBtnRead3() 
{
 int addr=0;
 sscanf(m_strBse3, "%x", &addr);
 OnRead(addr,3);
}
void CTestInterface::OnBtnWrite3() 
{
 int addr=0;
 sscanf(m_strBse3, "%x", &addr);
 OnWrite(addr,3);
}
void CTestInterface::OnBtnRead4() 
{
 int addr=0;
 sscanf(m_strBse4, "%x", &addr);
 OnRead(addr,4);
}
void CTestInterface::OnBtnWrite4() 
{
 int addr=0;
 sscanf(m_strBse4, "%x", &addr);
 OnWrite(addr,4);
}
void CTestInterface::OnBtnRead5() 
{
 int addr=0;
 sscanf(m_strBse5, "%x", &addr);
 OnRead(addr,5);
}
void CTestInterface::OnBtnWrite5() 
{
 int addr=0;
 sscanf(m_strBse5, "%x", &addr);
 OnWrite(addr,5);
}
void CTestInterface::OnBtnRead6() 
{
 int addr=0;
 sscanf(m_strBse6, "%x", &addr);
 OnRead(addr,6);
}
void CTestInterface::OnBtnWrite6() 
{
 int addr=0;
 sscanf(m_strBse6, "%x", &addr);
 OnWrite(addr,6);
}
void CTestInterface::OnBtnRead7() 
{
 int addr=0;
 sscanf(m_strBse7, "%x", &addr);
 OnRead(addr,7);
}
void CTestInterface::OnBtnWrite7() 
{
 int addr=0;
 sscanf(m_strBse7, "%x", &addr);
 OnWrite(addr,7);
}

void CTestInterface::OnRead(int portAdd,int nRegister) 
{
	WORD inNum;

	if( nVersione == DIRECTACCESS)
	 inNum = _inp(portAdd);
    else
  	 inNum = Inport(portAdd);

	word.dw = inNum;



    if(nRegister == 0){
	 m_bChk1_0 = GetBit(0);
	 m_bChk1_1 = GetBit(1);
	 m_bChk1_2 = GetBit(2);
	 m_bChk1_3 = GetBit(3);
	 m_bChk1_4 = GetBit(4);
	 m_bChk1_5 = GetBit(5);
	 m_bChk1_6 = GetBit(6);
	 m_bChk1_7 = GetBit(7);
	 m_strVal0.Format("R: %x",inNum);
	}

    if(nRegister == 1){
	 m_bChk2_0 = GetBit(0);
	 m_bChk2_1 = GetBit(1);
	 m_bChk2_2 = GetBit(2);
	 m_bChk2_3 = GetBit(3);
	 m_bChk2_4 = GetBit(4);
	 m_bChk2_5 = GetBit(5);
	 m_bChk2_6 = GetBit(6);
	 m_bChk2_7 = GetBit(7);
	 m_strVal1.Format("R: %x",inNum);
	}

    if(nRegister == 2){
	 m_bChk3_0 = GetBit(0);
	 m_bChk3_1 = GetBit(1);
	 m_bChk3_2 = GetBit(2);
	 m_bChk3_3 = GetBit(3);
	 m_bChk3_4 = GetBit(4);
	 m_bChk3_5 = GetBit(5);
	 m_bChk3_6 = GetBit(6);
	 m_bChk3_7 = GetBit(7);
	 m_strVal2.Format("R: %x",inNum);
	}

    if(nRegister == 3){
	 m_bChk4_0 = GetBit(0);
	 m_bChk4_1 = GetBit(1);
	 m_bChk4_2 = GetBit(2);
	 m_bChk4_3 = GetBit(3);
	 m_bChk4_4 = GetBit(4);
	 m_bChk4_5 = GetBit(5);
	 m_bChk4_6 = GetBit(6);
	 m_bChk4_7 = GetBit(7);
	 m_strVal3.Format("R: %x",inNum);
	}

    if(nRegister == 4){
	 m_bChk5_0 = GetBit(0);
	 m_bChk5_1 = GetBit(1);
	 m_bChk5_2 = GetBit(2);
	 m_bChk5_3 = GetBit(3);
	 m_bChk5_4 = GetBit(4);
	 m_bChk5_5 = GetBit(5);
	 m_bChk5_6 = GetBit(6);
	 m_bChk5_7 = GetBit(7);
	 m_strVal4.Format("R: %x",inNum);
	}


    if(nRegister == 5){
	 m_bChk6_0 = GetBit(0);
	 m_bChk6_1 = GetBit(1);
	 m_bChk6_2 = GetBit(2);
	 m_bChk6_3 = GetBit(3);
	 m_bChk6_4 = GetBit(4);
	 m_bChk6_5 = GetBit(5);
	 m_bChk6_6 = GetBit(6);
	 m_bChk6_7 = GetBit(7);
	 m_strVal5.Format("R: %x",inNum);
	}
	
    if(nRegister == 6){
	 m_bChk7_0 = GetBit(0);
	 m_bChk7_1 = GetBit(1);
	 m_bChk7_2 = GetBit(2);
	 m_bChk7_3 = GetBit(3);
	 m_bChk7_4 = GetBit(4);
	 m_bChk7_5 = GetBit(5);
	 m_bChk7_6 = GetBit(6);
	 m_bChk7_7 = GetBit(7);
	 m_strVal6.Format("R: %x",inNum);
	}

    if(nRegister == 7){
	 m_bChk8_0 = GetBit(0);
	 m_bChk8_1 = GetBit(1);
	 m_bChk8_2 = GetBit(2);
	 m_bChk8_3 = GetBit(3);
	 m_bChk8_4 = GetBit(4);
	 m_bChk8_5 = GetBit(5);
	 m_bChk8_6 = GetBit(6);
	 m_bChk8_7 = GetBit(7);
	 m_strVal7.Format("R: %x",inNum);
	}

	UpdateData(FALSE);
}

void CTestInterface::OnWrite(int portAdd,int nRegister) 
{

	UpdateData(TRUE);

    if(nRegister == 0){
	 dato.bit.b0 =m_bChk1_0;
	 dato.bit.b1 =m_bChk1_1;
	 dato.bit.b2 =m_bChk1_2;
	 dato.bit.b3 =m_bChk1_3;
	 dato.bit.b4 =m_bChk1_4;
	 dato.bit.b5 =m_bChk1_5;
	 dato.bit.b6 =m_bChk1_6;
	 dato.bit.b7 =m_bChk1_7;
	 m_strVal0.Format("W: %x",dato.byte);
	}
    if(nRegister == 1){
	 dato.bit.b0 =m_bChk2_0;
	 dato.bit.b1 =m_bChk2_1;
	 dato.bit.b2 =m_bChk2_2;
	 dato.bit.b3 =m_bChk2_3;
	 dato.bit.b4 =m_bChk2_4;
	 dato.bit.b5 =m_bChk2_5;
	 dato.bit.b6 =m_bChk2_6;
	 dato.bit.b7 =m_bChk2_7;
	 m_strVal1.Format("W: %x",dato.byte);
	}
    if(nRegister == 2){
	 dato.bit.b0 =m_bChk3_0;
	 dato.bit.b1 =m_bChk3_1;
	 dato.bit.b2 =m_bChk3_2;
	 dato.bit.b3 =m_bChk3_3;
	 dato.bit.b4 =m_bChk3_4;
	 dato.bit.b5 =m_bChk3_5;
	 dato.bit.b6 =m_bChk3_6;
	 dato.bit.b7 =m_bChk3_7;
	 m_strVal2.Format("W: %x",dato.byte);
	}
    if(nRegister == 3){
	 dato.bit.b0 =m_bChk4_0;
	 dato.bit.b1 =m_bChk4_1;
	 dato.bit.b2 =m_bChk4_2;
	 dato.bit.b3 =m_bChk4_3;
	 dato.bit.b4 =m_bChk4_4;
	 dato.bit.b5 =m_bChk4_5;
	 dato.bit.b6 =m_bChk4_6;
	 dato.bit.b7 =m_bChk4_7;
	 m_strVal3.Format("W: %x",dato.byte);
	}
    if(nRegister == 4){
	 dato.bit.b0 =m_bChk5_0;
	 dato.bit.b1 =m_bChk5_1;
	 dato.bit.b2 =m_bChk5_2;
	 dato.bit.b3 =m_bChk5_3;
	 dato.bit.b4 =m_bChk5_4;
	 dato.bit.b5 =m_bChk5_5;
	 dato.bit.b6 =m_bChk5_6;
	 dato.bit.b7 =m_bChk5_7;
	 m_strVal4.Format("W: %x",dato.byte);
	}
    if(nRegister == 5){
	 dato.bit.b0 =m_bChk6_0;
	 dato.bit.b1 =m_bChk6_1;
	 dato.bit.b2 =m_bChk6_2;
	 dato.bit.b3 =m_bChk6_3;
	 dato.bit.b4 =m_bChk6_4;
	 dato.bit.b5 =m_bChk6_5;
	 dato.bit.b6 =m_bChk6_6;
	 dato.bit.b7 =m_bChk6_7;
	 m_strVal5.Format("W: %x",dato.byte);
	}
    if(nRegister == 6){
	 dato.bit.b0 =m_bChk7_0;
	 dato.bit.b1 =m_bChk7_1;
	 dato.bit.b2 =m_bChk7_2;
	 dato.bit.b3 =m_bChk7_3;
	 dato.bit.b4 =m_bChk7_4;
	 dato.bit.b5 =m_bChk7_5;
	 dato.bit.b6 =m_bChk7_6;
	 dato.bit.b7 =m_bChk7_7;
	 m_strVal6.Format("W: %x",dato.byte);
	}
    if(nRegister == 8){
	 dato.bit.b0 =m_bChk8_0;
	 dato.bit.b1 =m_bChk8_1;
	 dato.bit.b2 =m_bChk8_2;
	 dato.bit.b3 =m_bChk8_3;
	 dato.bit.b4 =m_bChk8_4;
	 dato.bit.b5 =m_bChk8_5;
	 dato.bit.b6 =m_bChk8_6;
	 dato.bit.b7 =m_bChk8_7;
	 m_strVal7.Format("W: %x",dato.byte);
	}
	if( nVersione == DIRECTACCESS)
	 _outp(portAdd,dato.byte);
    else
  	 Outport(portAdd,dato.byte);
	UpdateData(FALSE);
}



//Restituisce il valore del bit specificato
int CTestInterface::GetBit(int nBit){
 if(nBit<0)
  return 2; //Led Disabilitato

 if(nBit<8){
  dato.byte=word.byte.msb;
  switch(nBit){
   case 0: return dato.bit.b0;
   case 1: return dato.bit.b1;
   case 2: return dato.bit.b2;
   case 3: return dato.bit.b3;
   case 4: return dato.bit.b4;
   case 5: return dato.bit.b5;
   case 6: return dato.bit.b6;
   case 7: return dato.bit.b7;
   default: return FALSE;
  }
 }else{
  dato.byte=word.byte.lsb;
  switch(nBit){
   case  8: return dato.bit.b0; 
   case  9: return dato.bit.b1;
   case 10: return dato.bit.b2;
   case 11: return dato.bit.b3;
   case 12: return dato.bit.b4;
   case 13: return dato.bit.b5;
   case 14: return dato.bit.b6;
   case 15: return dato.bit.b7;
   default: return FALSE;
  }
 }
}


BOOL CTestInterface::GetSystemVersion(int& nVersione,CString& vers,CString& tipo,CString& srvpack)
{
   OSVERSIONINFOEX osvi;
   BOOL bOsVersionInfoEx;
   nVersione = 0; //No info
   vers=_T("");
   tipo=_T("");
   srvpack=_T("");

   // Try calling GetVersionEx using the OSVERSIONINFOEX structure.
   // If that fails, try using the OSVERSIONINFO structure.

   ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
   osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

   if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
   {
      // If OSVERSIONINFOEX doesn't work, try OSVERSIONINFO.

      osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
      if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
         return FALSE;
   }

   switch (osvi.dwPlatformId)
   {
      case VER_PLATFORM_WIN32_NT:

      // Test for the product.

		 if ( osvi.dwMajorVersion <= 4 ){
            vers="Microsoft Windows NT ";
            nVersione = WNT; //
		 }

         if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0 ){
            vers="Microsoft Windows 2000 ";
			nVersione = W2K; 
		 }

         if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1 ){
            vers="Microsoft XP (Whistler) ";
			nVersione = WXP; //
		 }
/*
      // Test for product type. SOLO SU SRVPACK 6

         if( bOsVersionInfoEx )
         {
            if ( osvi.wProductType == VER_NT_WORKSTATION )
            {
				if( osvi.wSuiteMask & VER_SUITE_PERSONAL ){
                  tipo="Personal ";
				}else{
                  tipo="Professional ";
				}
            }

            else if ( osvi.wProductType == VER_NT_SERVER )
            {
               if( osvi.wSuiteMask & VER_SUITE_DATACENTER )
                  tipo=""DataCenter Server ";
               else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE )
                  tipo=""Advanced Server ";
               else
                  tipo=""Server ";
            }
         }
         else
         {
            HKEY hKey;
            char szProductType[80];
            DWORD dwBufLen;

            RegOpenKeyEx( HKEY_LOCAL_MACHINE,
               "SYSTEM\\CurrentControlSet\\Control\\ProductOptions",
               0, KEY_QUERY_VALUE, &hKey );
            RegQueryValueEx( hKey, "ProductType", NULL, NULL,
               (LPBYTE) szProductType, &dwBufLen);
            RegCloseKey( hKey );
            if ( lstrcmpi( "WINNT", szProductType) == 0 )
               tipo=""Workstation ";
            if ( lstrcmpi( "SERVERNT", szProductType) == 0 )
               tipo=""Server ";
         }
*/

      // Display version, service pack (if any), and build number.

         if ( osvi.dwMajorVersion <= 4 )
         {
            srvpack.Format("version %d.%d %s (Build %d)\n",
               osvi.dwMajorVersion,
               osvi.dwMinorVersion,
               osvi.szCSDVersion,
               osvi.dwBuildNumber & 0xFFFF);
         }
         else
         { 
            srvpack.Format("%s (Build %d)\n",
               osvi.szCSDVersion,
               osvi.dwBuildNumber & 0xFFFF);
         }
         break;

      case VER_PLATFORM_WIN32_WINDOWS:

         if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0)
         {
             nVersione = W95; 
             vers="Microsoft Windows 95 ";
             if ( osvi.szCSDVersion[1] == 'C' )
                tipo="OSR2 ";
         } 

         if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 10)
         {
			 nVersione = W98; 
             vers="Microsoft Windows 98 ";
             if ( osvi.szCSDVersion[1] == 'A' )
                tipo="SE ";
         } 

         if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 90)
         {
			 nVersione = WME; 
             vers="Microsoft Windows Me ";
         } 
         break;

      case VER_PLATFORM_WIN32s:
         nVersione = W32S; 
         vers="Microsoft Win32s ";
         break;
   }
   return TRUE; 
}

void CTestInterface::OnChangeEdtBse0() 
{
	UpdateData(TRUE);
	sscanf(m_strBse0, "%x", &m_nPortBse);
    m_strBse1.Format("%x",m_nPortBse+1);
	m_strBse2.Format("%x",m_nPortBse+2);
    m_strBse3.Format("%x",m_nPortBse+0x400);
	m_strBse4.Format("%x",m_nPortBse+0x401);
    m_strBse5.Format("%x",m_nPortBse+0x402);
	m_strBse6.Format("%x",m_nPortBse+3);
    m_strBse7.Format("%x",m_nPortBse+4);
	UpdateData(FALSE);
}

void CTestInterface::OnTimer(UINT nIDEvent) 
<{
 int addr=0;
 if(IDT_TM_CHK == nIDEvent && !m_bTestMode){
  KillTimer(nIDEvent);

  sscanf(m_strBse0, "%x", &addr);
  OnRead(addr,0);
  sscanf(m_strBse1, "%x", &addr);
  OnRead(addr,1);
  sscanf(m_strBse2, "%x", &addr);
  OnRead(addr,2);
  sscanf(m_strBse3, "%x", &addr);
  OnRead(addr,3);
  sscanf(m_strBse4, "%x", &addr);
  OnRead(addr,4);
  sscanf(m_strBse5, "%x", &addr);
  OnRead(addr,5);
  sscanf(m_strBse6, "%x", &addr);
  OnRead(addr,6);
  sscanf(m_strBse7, "%x", &addr);
  OnRead(addr,7);

  SetTimer(nIDEvent,tmSleep,NULL);
 }
 if(IDT_TM_CHK == nIDEvent && m_bTestMode){
  KillTimer(nIDEvent);

  sscanf(m_strBse0, "%x", &addr);
  WriteDataSingleBit(addr,m_nWrtBit++);
  if(m_nWrtBit > 7) m_nWrtBit=0;

  SetTimer(nIDEvent,tmSleep,NULL);
 }
}

void CTestInterface::OnChkTmread() 
{
  UpdateData(TRUE);
  if(m_bAutoRefresh == TRUE){
    tmSleep=atoi(m_strTmTimer);
	SetTimer(IDT_TM_CHK,tmSleep,NULL);
  }else
   KillTimer(IDT_TM_CHK);
}

void CTestInterface::OnSetfocusEdtTm() 
{
 if(m_bAutoRefresh == TRUE)
  KillTimer(IDT_TM_CHK);
}

void CTestInterface::OnKillfocusEdtTm() 
{
 OnChkTmread();
}

void CTestInterface::OnChkTest() 
{
 UpdateData(TRUE);
 if(m_bTestMode){
  m_nWrtBit=0;
  m_bAutoRefresh=TRUE;
 }else{
  m_bAutoRefresh=FALSE;
 }
 UpdateData(FALSE);
 OnChkTmread(); 
}

void CTestInterface::WriteDataSingleBit(int portAdd,int nBit){
 int mask=0x1;
 int ControlPortAddr=portAdd+2;

 dato.byte = 0x0d; //1101 Set High
 m_strVal0.Format("W: %x",dato.byte);
 if( nVersione == DIRECTACCESS)
  _outp(portAdd,dato.byte);
 else
  Outport(ControlPortAddr,dato.byte);
 m_strVal2.Format("W: %x",dato.byte);

 dato.byte = 0x00;  //Set data bit 
 dato.byte = mask << nBit;

 m_strVal0.Format("W: %x",dato.byte);
 if( nVersione == DIRECTACCESS)
  _outp(portAdd,dato.byte);
 else
  Outport(portAdd,dato.byte);
 m_strVal0.Format("W: %x",dato.byte);

 dato.byte = 0x0c; //1100 Write
 if( nVersione == DIRECTACCESS)
  _outp(portAdd,dato.byte);
 else
  Outport(ControlPortAddr,dato.byte);
 m_strVal2.Format("W: %x",dato.byte);

 OnRead(portAdd,0);
 UpdateData(FALSE);
}